// KING' KNIGHT Special (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int calc_sum(unsigned char *_ptr)
{
	unsigned char *_p = _ptr;
	int sum=0;
	for (int i=0; i<0x100; i++)
	{
		sum+=*(_p++);
	}
	sum&=0xffff;
	return sum;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i;
	unsigned char id0[] = "King\' Knight Sys";
//	int id1 = 0x6015;
	int id2 = 0xe500;
	int dn = -1;

	// Disk 1
	struct fpos md1[] =
	{
		{ 0x05, 0x01, 0x0a00 },
		{ 0x05, 0x0b, 0x0a00 },
		{ 0x06, 0x05, 0x0a00 },
		{ 0x06, 0x0f, 0x0a00 },
		{ 0x07, 0x09, 0x0a00 },
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	// Disk 2
	struct fpos md2[] =
	{
		{ 0x3e, 0x0f, 0x0700 },	// 
		{ 0x3f, 0x06, 0x0700 },	// 
		{ 0x3f, 0x0d, 0x0700 },	// 
		{ 0x40, 0x04, 0x0700 },	// 
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc < 2 || argc > 3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
	}

	if (argc==3)
	{
		// fBXNԍw
		dn = *argv[2]-'0';
		if (dn<1 || dn>2)
		{
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
		}
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x300);
		if (memcmp(&buff[1], id0, sizeof(id0)-1))
		{
			fprintf(stderr, "̃fBXNKING' KNIGHT Special(X1)̂̂ł͂Ȃ悤ł.\n",argv[0]);
			break;
		}
		// Tr.0 Sec.3ŃfBXN
		if ((calc_sum(&buff[0x200])!=id2 && dn==-1) || dn==1)
		{
			printf("Disk 1 F܂.\n");
			fcut("LOGO", 0x17, 0x0b, 0x01, 0x01, 0x01, 0x0000, 0x2d00);
			fcut("PROG", 0x01, 0x00, 0x01, 0x01, 0x01, 0x0000, 0x2500);
			for (i=0; md1[i].sec; i++)
			{
				sprintf(fname,"MUS%02d",i);
				fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x01, 0x0000, md1[i].size);
			}
		}
		else if ((calc_sum(&buff[0x200])==id2 && dn==-1) || dn==2)
		{
			printf("Disk 2 F܂.\n");
			for (i=0; md1[i].trk; i++)
			{
				sprintf(fname,"MUS%02d",i+5);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x01, 0x0000, md2[i].size);
			}
		}
	}
	return 0;
}

